typedef struct sockev_buffer_s sockev_buffer_t;

/* initialize an empty buffer */
void sockev_buffer_init(sockev_buffer_t *buffer);

/* copy append b/len to the buffer */
void sockev_buffer_append(sockev_buffer_t *buffer, const char *b, int len);

/* set a pointer (b) and tell length (len) of the next chunk
   return 0 on success and -1 if buffer is empty */
int sockev_buffer_get(sockev_buffer_t *buffer, const char **b, int *len);

/* after writing out a chunk (after call to sockev_buffer_get()), remove the chunk from the buffer */
void sockev_buffer_remove(sockev_buffer_t *buffer, int len);

/* return total number of bytes stored in the buffer */
int sockev_buffer_total(sockev_buffer_t *buffer);

/* drop all pending data, free all resources */
void sockev_buffer_uninit(sockev_buffer_t *buffer);

/* --- internals --- */
typedef struct sockev_buff_s sockev_buff_t;

struct sockev_buffer_s {
	sockev_buff_t *first;
	sockev_buff_t *last;
	int total;
};

