/* Make reads and writes atomic - when sockev_write() is called with an
   arbitrary length, it is guaranteed that read event on the other end will
   be called with the same length. This allows the caller to ensure that
   variable sized packets are received as atoms.

   This is done by inserting a 4 bytes long (signed) "length" field before
   each packet on the sender side and wait for all bytes of a packet (after
   reading the length field) on receiver side.

   At initialization the user needs to provide a maximum packet size; the
   filter will allocate a buffer of this size. Any packet larger than this
   size will cause the connection to break. Maximum packet size
   should be P_int32_t.
*/

void sockev_filter_packet(sockev_t id, void **sockdata, sockev_f_dir_t event, void *data_, int len, int cookie);
